//=============================================================================
// 自分用
// ----------------------------------------------------------------------------
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// このプラグインはもう自分のものです。
// ----------------------------------------------------------------------------
//=============================================================================

/*:ja
 * @target MZ
 * @plugindesc 自分用いろいろ
 * @author きぎぬ
 * @url http://r3jou.web.fc2.com/index.html
 * @help 自分用
 *
 */

(() => {


//吹き出しアイコンの表示時間いじる
Sprite_Balloon.prototype.speed = function() {
    return 4;//本来は8
};
Sprite_Balloon.prototype.waitTime = function() {
    return 6;//本来は12
};

//メッセージウィンドウで顔グラ表示するときの顔インデックスを変数に代入する
//あとでコモンイベントで数字に応じて対応立ち絵を表示するための布石である。
Window_Message.prototype.drawMessageFace = function() {
    const faceName = $gameMessage.faceName();
    $gameVariables.setValue(21,faceName);
    const faceIndex = $gameMessage.faceIndex();
    $gameVariables.setValue(22,faceIndex);
    //console.log($gameVariables.value(21));
    //console.log($gameVariables.value(22));
    const rtl = $gameMessage.isRTL();
    const width = ImageManager.faceWidth;
    const height = this.innerHeight;
    const x = rtl ? this.innerWidth - width - 4 : 4;
    this.drawFace(faceName, faceIndex, x, 0, width, height);
};

//メニューコマンドで一部を封印したいときの改造ね。特に装備ね。
Window_MenuCommand.prototype.addMainCommands = function() {
    const enabled = this.areMainCommandsEnabled();
    if (this.needsCommand("item")) {
        this.addCommand(TextManager.item, "item", enabled);
    }
    if (this.needsCommand("skill")) {
        this.addCommand(TextManager.skill, "skill", enabled);
    }
    if (this.needsCommand("equip")) {
	//enabledの反対はdisabledだろって思ったらそんなものなかった。中身はtrue/falseだった。罠だわ。
	if($gameVariables.value(34) == 3) this.addCommand(TextManager.equip, "equip", false);
        else this.addCommand(TextManager.equip, "equip", enabled);
    }
    if (this.needsCommand("status")) {
        this.addCommand(TextManager.status, "status", enabled);
    }
};

/*
//11->start,10->select,9->R3,8->L3,7->RT,6->LT
//ゲームパッドのLTを、キーボードにおけるcontrolとする
    Input.gamepadMapper[6] = 'control';
*/

/*
Input.gamepadMapper = {
    0: "ok", // A
    1: "cancel", // B
    2: "shift", // X
    3: "menu", // Y
    4: "pageup", // LB
    5: "pagedown", // RB
	9: "control",
    12: "up", // D-pad up
    13: "down", // D-pad down
    14: "left", // D-pad left
    15: "right" // D-pad right
};
*/

/*
//メニューコマンドの順番を入れ替える場合は以下をいじる
Window_MenuCommand.prototype.makeCommandList = function() {
    this.addMainCommands();
    this.addFormationCommand();
    this.addOriginalCommands();
    this.addOptionsCommand();
    this.addSaveCommand();
    this.addGameEndCommand();
};
Window_MenuCommand.prototype.addMainCommands = function() {
    const enabled = this.areMainCommandsEnabled();
    if (this.needsCommand("item")) {
        this.addCommand(TextManager.item, "item", enabled);
    }
    if (this.needsCommand("skill")) {
        this.addCommand(TextManager.skill, "skill", enabled);
    }
    if (this.needsCommand("equip")) {
        this.addCommand(TextManager.equip, "equip", enabled);
    }
    if (this.needsCommand("status")) {
        this.addCommand(TextManager.status, "status", enabled);
    }
};
*/

/*
//次のレベルまでをメニュー画面に表示させたい
//関数新たに増設
Window_StatusBase.prototype.drawActorNextLevel = function(actor, x, y) {
    this.changeTextColor(ColorManager.systemColor());
	this.contents.fontSize -= 8;
    this.drawText('Next', x, y, 48);
    this.resetTextColor();
    this.drawText(actor.nextRequiredExp(), x + 84, y, 44, "right");
	this.contents.fontSize += 8;
};
*/


/*
//命中-回避、書き換え
Game_Action.prototype.apply = function(target) {
    const result = target.result();
    this.subject().clearResult();
    result.clear();
    result.used = this.testApply(target);
    //result.missed = result.used && Math.random() >= this.itemHit(target);
    result.missed = false;//ノーミス
    //result.evaded = !result.missed && Math.random() < this.itemEva(target);
    result.evaded = (result.used && Math.random() >= (this.itemHit(target) - this.itemEva(target)));//命中-回避
    result.physical = this.isPhysical();
    result.drain = this.isDrain();
    if (result.isHit()) {
        if (this.item().damage.type > 0) {
            result.critical = Math.random() < this.itemCri(target);
            const value = this.makeDamageValue(target, result.critical);
            this.executeDamage(target, value);
        }
        for (const effect of this.item().effects) {
            this.applyItemEffect(target, effect);
        }
        this.applyItemUserEffect(target);
    }
    this.updateLastTarget(target);
};
*/

///*
//戦闘開始時に導出される、逃走確率計算処理
BattleManager.makeEscapeRatio = function() {
    //this._escapeRatio = (0.5 * $gameParty.agility()) / $gameTroop.agility();
	//狙われ率を逃走成功アップ率にする。通常で1.0。掛け算。
	this._escapeRatio = (0.5 * $gameParty.agility() * $gameParty.tgrSum()) / $gameTroop.agility();
	//console.log('escapeRatio:' + this._escapeRatio);
	$gameVariables.setValue(10,0);//初期化
	if(this._escapeRatio >= 1.0){
		$gameVariables.setValue(10,parseInt(this._escapeRatio * 100) - 100);//はみ出た量あとでなんかに使えないかな
		this._escapeRatio = 1.0;
	}
	$gameVariables.setValue(9,parseInt(this._escapeRatio * 100));//変数9に代入してできれば戦闘中に表示できたらなあ
};
//逃走失敗時の処理
BattleManager.onEscapeFailure = function() {
	$gameParty.onEscapeFailure();
	this.displayEscapeFailureMessage();
	this._escapeRatio += 0.1;
	if(this._escapeRatio >= 1.0){
		$gameVariables.setValue(10,parseInt(this._escapeRatio * 100) - 100);//はみ出た量あとでなんかに使えないかな
		this._escapeRatio = 1.0;
	}
	$gameVariables.setValue(9,parseInt(this._escapeRatio * 100));//変数9に代入してできれば戦闘中に表示できたらなあ
	//
	if (!this.isTpb()) {
		this.startTurn();
	}
};
//パーティコマンド開いたときにスイッチONして逃走確率ウィンドウを出したい
/*
Scene_Battle.prototype.startPartyCommandSelection = function() {
    this._statusWindow.deselect();
    this._statusWindow.show();
    this._statusWindow.open();
    this._actorCommandWindow.setup(null);
    this._actorCommandWindow.close();
	if(BattleManager.canEscape()){
		$gameSwitches.setValue(15,true);
	}
    this._partyCommandWindow.setup();
};
*/
/*
//こっちのほうがいいか？
Window_PartyCommand.prototype.makeCommandList = function() {
    this.addCommand(TextManager.fight, "fight");
    this.addCommand(TextManager.escape, "escape", BattleManager.canEscape());
	if(BattleManager.canEscape()){
		$gameSwitches.setValue(15,true);
	}
};
*/

//決定稿。逃走コマンドのところに逃走確率を書いてしまう。ウィンドウ出す処理は複雑になってしまう。
Window_PartyCommand.prototype.makeCommandList = function() {
	this.addCommand(TextManager.fight, "fight");
	if(BattleManager.canEscape()){
		this.addCommand(TextManager.escape + '(' + $gameVariables.value(9) + '%)', "escape", BattleManager.canEscape());
	}else{
		this.addCommand(TextManager.escape + '(※無理)', "escape", BattleManager.canEscape());
	}
};


/* これはtriacontane/extrawindowのパラメータで指定したものと組み合わせるやり方。

//パーティコマンド閉じたとき(戦うを選んだ時)にスイッチOFFして逃走確率ウィンドウを消したい
Scene_Battle.prototype.startActorCommandSelection = function() {
    this._statusWindow.show();
    this._statusWindow.selectActor(BattleManager.actor());
    this._partyCommandWindow.close();
	$gameSwitches.setValue(15,false);
    this._actorCommandWindow.show();
    this._actorCommandWindow.setup(BattleManager.actor());
};

//逃走コマンドを選んだ時にスイッチOFFして逃走確率ウィンドウを消したい。これ忘れると逃走成功した次の戦闘で最初から出ちゃう
Scene_Battle.prototype.commandEscape = function() {
    BattleManager.processEscape();
    this.changeInputWindow();
	$gameSwitches.setValue(15,false);
};

//こっちのほうがいいか？
BattleManager.checkBattleEnd = function() {
    if (this._phase) {
        if (this.checkAbort()) {
		$gameSwitches.setValue(15,false);
            return true;
        } else if ($gameParty.isAllDead()) {
		$gameSwitches.setValue(15,false);
            this.processDefeat();
            return true;
        } else if ($gameTroop.isAllDead()) {
		$gameSwitches.setValue(15,false);
            this.processVictory();
            return true;
        }
    }
    return false;
};

*/

})();
